//  PLOrX Aeterna
//  by Perry R. Cook
// for PLOrk, April 2012

// 6 => int channels;
2 => int channels;

float SENSEX, SENSEY; FileIO config;  getConfig();

540 => float XMAX => float YMAX;

MAUI_View myWinder;
MAUI_Button score, capButt, sections[5];
MAUI_LED dude; 
doGUI();

Hid hi;  HidMsg msg;
if( !hi.openTiltSensor() )  {
    <<< "tilt sensor unavailable", "" >>>;
    me.exit();
}

float theta,vx,vy,ax,ay;  // physics variables we might need
30 => float x;  YMAX => float y;  // more physics variables
0.90 => float DAMP;               // to control our "marble"

Gain Center => dac;
Gain Left => dac.left;
Gain Right => dac.right;
Gain Channels[6];
    
adc => Gain inGain => Delay del => Gain outGain => PitShift p0 => Center;
del => Gain fbGain => del;
0.0 => float tiltTarg;
0.0 => inGain.gain => fbGain.gain => outGain.gain;
2.0 :: second => del.max => del.delay;
outGain => PitShift p1 => Delay dl => NRev rl => Left;
outGain => PitShift p2 => Delay dr => NRev rr => Right;

1.0 => float p0Targ => float p1Targ => float p2Targ;
dl => Gain dlFB => dl; 0.8 => dlFB.gain;
dr => Gain drFB => dr; 0.8 => drFB.gain;
1.1 :: second => dl.max => dl.delay;
1.33 :: second => dr.max => dr.delay;
0.0 => float dlTarg;
0.05 => rl.mix => rr.mix;

// Zero Crossing (x2) counter
adc => ZeroX z => FullRect f => OnePole p => blackhole;	// basic patch
-1.0 => p.a1; 		// This is dangerous, 
1.0 => p.b0; 		// but we know what we're doing
0 => float myZeroes;

// Pseudo RMS calculator (envelope follower)
adc => OnePole power => blackhole;
adc => power; 3 => power.op;
0.99 => power.pole;
0.01 => float THRESHOLD;

Delay ksHold[6];
adc => Delay ksCapture => blackhole;
0.2 :: second => ksCapture.max => ksCapture.delay;
ksCapture => Gain ksGain => NRev rev;
0.02 => rev.mix;
0.0 => ksGain.gain;
for (0 => int i; i < 6; i++)  {
    rev => ksHold[i];
    if (i % 3 == 0) ksHold[i] => Left; // Stereo for testing
    else if (i % 3 == 1) ksHold[i] => Center;  // Stereo for testing
    else       ksHold[i] => Right; // Stereo for testing
    if (channels==6) ksHold[i] => dac.chan(i);  // 6 channel for hemi
    (1.0 + 0.211*i) :: second => ksHold[i].max => ksHold[i].delay;
    ksHold[i] => ksHold[i];
    0.9 => ksHold[i].gain;
}

1 => int ZCount;

0 => int Section;
spork ~ smoothStuff();

//   OK, Here's the piece, which calls lots of stuff below
int myDrone;
Section0();
1 => Section;
Section1();
Machine.add("Drone2.ck") => myDrone;
0 => sections[0].state;  1 => sections[1].state;
score.name("");
score.setImage("LORXScore2.png");
Section2n3n5();
Machine.add("Drone.ck") => myDrone;
sections[1].name("Part 3");
score.name("");
score.unsetImage();
score.setImage("LORXScore3.png");
Section2n3n5();
0.0 => fbGain.gain;
Machine.add("Drone.ck") => myDrone;
score.setImage("LORXScore4.png");
0 => sections[1].state;  1 => sections[2].state;
Section4();
Machine.add("Drone.ck") => myDrone;
0 => sections[2].state;  1 => sections[3].state;
score.name("");
score.setImage("LORXScore5.png");
Section2n3n5(); 5 => Section;
Section2n3n5(); 5 => Section;
Section2n3n5();
score.unsetImage();
score.name("Section 6 coming soon.....\n\nFor now, smile and bow... :-)");
1.0 => tiltTarg;
5.0 :: second => now;
ditchIt();
//  END OF PIECE, Below here are functions  **************

//  Pre-piece, instructions, hang out...
fun void Section0()  {
    updatePhysics();
    score.size(600,250);
    score.position(0,200);
    score.setImage("LORXScore0.png"); 2.0 :: second => now;
    score.unsetImage();
    score.setImage("LORXScore1.png"); 0.1 :: second => now;
    score.unsetImage();
    score.setImage("LORXScore2.png"); 0.1 :: second => now;
    score.unsetImage();
    score.setImage("LORXScore3.png"); 0.1 :: second => now;
    score.unsetImage();
    score.setImage("LORXScore4.png"); 0.1 :: second => now;
    score.unsetImage();
    score.size(600,150);
    score.name("You'll get instructions here\n\nStay tuned!!\n\n(If you need to exit for some reason, you can click here)");
    30 => x;
    YMAX => y;
    if (score.state()==1) ditchIt();
    4.0 :: second => now;
    score.name("Lean forward, take a few breaths...\n\n\n(Remember you can click here to exit)");
    Machine.add("Drone.ck") => myDrone;
    if (score.state()==1) ditchIt();
    5.0 :: second => now;
    if (score.state()==1) ditchIt();
    score.size(600,250);
    score.setImage("LORXScore1.png");
    capButt.position(0,0);
}

//  Section 1, LO-----, capture, release, move on
fun void Section1()  {
    0 => int Incr;
    1 => sections[0].state;
    //1 => int Section;
    <<< "Section ", Section >>>;
    while (Section == 1)  {
        0.05 :: second => now;
        updatePhysics();
        30 => x;
        y / YMAX => tiltTarg; // inGain.gain;
        if (score.state()) ditchIt();
        if (Incr == 0)  {    // wait until we've captured
            if (y < 100) {
                1 => Incr;  // some loops
                score.unsetImage();
                score.name("OK, Hang out here a bit,\nthen all lean forward together,\nwhile singing your next\n'LO---' on G (whole step up).");
            }
        }
        else {
            if (y > 530) 1 +=> Section; // then after that, go on
        }
    }
}

// Section 2, LO--- (or aeterna), capture, tilt left/right pitch chorusing
fun void Section2n3n5()  {
    YMAX => y; 0.0 => ay => vy;
    0 => int Incr;
    "Shift down ------ No Shift ------ Shift Up ------ Shift Up/Down ------ Shift Up More"
        => capButt.name;
    <<< "Section ", Section >>>;
    while (Incr < 2)  {
        0.05 :: second => now;
        updatePhysics();
        y / YMAX => tiltTarg;
        if (score.state()) ditchIt();
        if (y > 100) {
            if (Section < 5) 150 => x;
            else             390 => x;
        }
        else {
            if (dlTarg < 1.0) 1.0 => dlTarg;
            if (x < 100) {
                0.8909 => p0Targ => p1Targ => p2Targ;
            }
            else if (x < 200) {
                1.0 => p0Targ => p1Targ => p2Targ;
            }
            else if (x < 300) {
                1.12246 => p0Targ => p1Targ => p2Targ;
            }
            else if (x < 400) {
                1.0 => p0Targ;
                1.12246 => p1Targ;
                0.8909 => p2Targ;
            }
            else {
                1.0 => p0Targ;
                1.12246 => p1Targ;
                1.260 => p2Targ;
            }
        }
        if (Incr == 0)  {    // wait until we've captured
            if (y < 100) {   // some stuff in our loops
                1 => Incr;
            }
        }
        else {
            if (y > 530) {
                1 +=> Section; // then after that, go on
                3 => Incr;
            }
        }
    }
    if (dlTarg > 0.0) 0.0 => dlTarg;
    1.0 => p0Targ => p1Targ => p2Targ;
}

// Section 4:  KS Capture and messing about
fun void Section4()  {
    float zeroes, temp;
    spork ~ ZC(0.040);
    YMAX => y; 0.0 => ay => vy;
    0 => int Incr;
    "LO----- once again, then tilt up to here then....  distinct 'KS!!!'"
        => capButt.name;
    while (Section == 4)  {
        0.05 :: second => now;
        updatePhysics();
        y / YMAX => tiltTarg;
        270 => x;
        0.04 :: second => now;	// hang out a bit
        if ( y < 50)   {
          if (power.last() < THRESHOLD)   { 
//            <<< "Silence for now... ", power.last() >>>;
            sections[2].name("Part4\n"+"Silence");
          }
          else {
            myZeroes/0.04/2.0 => zeroes;
            if (zeroes > 3500) {
//                <<< "Noise!!!", zeroes >>>;
                sections[2].name("Noise\n"+Std.ftoa(zeroes,0));
                YMAX => y; 0.0 => ay => vy;
                y / YMAX => tiltTarg;
                0 => ZCount;
                captureNoise();
            }
            else {
                myZeroes/0.04/2.0 => temp;
//                <<< "Freq. = ", temp >>>;
                 sections[2].name("Part4\n"+Std.ftoa(temp,2));
            }
          }
        }
        if (score.state()) ditchIt();
    }
}

fun void captureNoise()  {
    0.2 :: second => now;
    1.0 => ksGain.gain;
    0.4 :: second => now;
    0.0 => ksGain.gain;
    0.0 => float myTime;
    float temp;
    2.0 :: second => now;
    score.unsetImage();
    score.name("OK, lean forward and \nlet the randomized 'ks' \nring out for a while");
    capButt.name("OK, lean forward and let the randomized 'ks' ring out for a while");
    0.0 => vx => vy;
    YMAX => y;
    dude.position(x,y);
    while (myTime < 10.0)  {
        Std.rand2f(0.05,0.4) => temp;
        temp +=> myTime;
        temp :: second => now;	// hang out a bit
        Std.rand2f(0.2,1.0) :: second => ksHold[Std.rand2(0,5)].delay;
        if (score.state()==1) ditchIt();
    }
    for (0 => int i; i < 6; i++) {
        0.5 => ksHold[i].gain;
    }    
    5 => Section;
}

fun void ZC(float howoften)	{
    howoften*44100 - 1 => float wait;
    while (ZCount)	{
        wait :: samp => now;	// hang out counting
        p.last() => myZeroes;	// save count
        0.0 => p.a1 => p.b0;	// Clear our 
        1 :: samp => now;	    //     counter
        -1.0 => p.a1;		    // Start counting
        1.0 => p.b0;		    //   again
    }
}

fun void incrSection(float inTheseSeconds)  {
    inTheseSeconds :: second => now;
    1 +=> Section;
}

fun void smoothStuff()  {
    float temp;
    while (Section < 10)  {
        0.005 :: second => now;
        dl.gain()*0.99 + dlTarg*0.01 => dl.gain => dr.gain;
        inGain.gain() => temp;
        temp*0.99 + tiltTarg*0.01 => temp => inGain.gain;
        (1.0 - temp) => outGain.gain => fbGain.gain;
        p0.shift()*0.97 + p0Targ*0.03 => p0.shift;
        p1.shift()*0.97 + p1Targ*0.03 => p1.shift;
        p2.shift()*0.97 + p2Targ*0.03 => p2.shift;
    }
}

// Physics and stuff
fun void updatePhysics() {
    hi.read( 9, 0, msg );
    SENSEX*msg.x*0.01 => ax;
    -SENSEY*msg.y*0.01 => ay;
    vx*DAMP + ax => vx; 
    x + vx => x; 
    if (x > XMAX) {  XMAX => x; -vx => vx;  }
    if (x < 0) {  0 => x; -vx => vx; }
    vy*DAMP + ay => vy; 
    y + vy => y;
    if (y > YMAX) { YMAX => y;  -vy => vy; }
    if (y < 0) {   0 => y;  -vy => vy; }
    dude.position(x,y);
}    

10 => int TOLERANCE;
fun int checkButt(MAUI_Button butt)  {
    if (x > butt.x()-TOLERANCE & x < butt.x()+2*TOLERANCE 
    & y > butt.y()-TOLERANCE & y < butt.y()+2*TOLERANCE) return 1;
    else return 0;
}

// Setup routines moved down here...
fun void ditchIt()  { //  clean up with extreme predjudice
    10 => Section;
    myWinder.destroy();
    Machine.remove(myDrone);
    me.exit();
}

fun void getConfig()  {
    config.open( "CONFIG.txt", FileIO.READ );
    if (config.good())  {
        string in,token,value;
        StringTokenizer tok;
        config.readLine() => in; in => tok.set;
        tok.next(token); tok.next(value);
        Std.atof(value) => SENSEX;
        config.readLine() => in; in => tok.set;
        tok.next(token); tok.next(value);
        Std.atof(value) => SENSEY;
        config.close();
    }
    else {
        <<< "Need a CONFIG.txt file!!" >>>;
        me.exit();
    }
    <<< SENSEX, SENSEY >>>;
}    

fun void doGUI()  {
    myWinder.size(600,600);
    myWinder.name("LOrX Aeterna (by P. Cook, For PLOrk, April 2012)");
    score.size(600,150);
    score.name("You'll get instructions here\n\nStay tuned!!\n\n(If you need to exit for some reason, you can click here)");
    score.toggleType(); score.position(0,300);
    myWinder.addElement(score);
    capButt.size(600,80); capButt.position(1000,0);
    capButt.name("Full Capture Position");
    myWinder.addElement(capButt);
    for (0 => int i; i<5; i++) { 
        sections[i].size(120,90);
        sections[i].position(i*120,YMAX-20);
        sections[i].toggleType();
        myWinder.addElement(sections[i]);
    }
    sections[0].name("Part 1");
    sections[1].name("Part 2/3");
    sections[2].name("Part 4");
    sections[3].name("Part 5");
    sections[4].name("Part 6");
    dude.color(1); dude.light();
    myWinder.addElement(dude);
    myWinder.display();
}

    
